/* Generated by re2c 0.12.1 */
#line 1 "_mwscan.re"
// -*- mode: c++ -*-
// Copyright (c) 2007-2008 PediaPress GmbH
// See README.txt for additional licensing information.

#include <Python.h>

#include <iostream>
#include <assert.h>
#include <vector>
using namespace std;

#define RET(x) {found(x); return x;}

typedef enum {
	t_end,
	t_text,
	t_entity,
	t_special,
	t_magicword,
	t_comment,
	t_2box_open,   // [[
	t_2box_close,  // ]]
	t_http_url,
	t_break,
	t_begin_table,
	t_end_table,
	t_html_tag,
	t_singlequote,
	t_pre,
	t_section,
	t_section_end,
	t_item,
	t_colon,
	t_semicolon,
	t_hrule,
	t_newline,
	t_column,
	t_row,
	t_tablecaption,
	t_urllink,
} mwtok;

struct Token
{
	int type;
	int start;
	int len;
};

class Scanner
{
public:

	Scanner(Py_UNICODE *_start, Py_UNICODE *_end) {
		source = start = _start;
		end = _end;
		cursor = start;
		line_startswith_section = -1;
		tablemode=0;
	}

	int found(mwtok val) {
		if (val==t_text && tokens.size()) {
			Token &previous_token (tokens[tokens.size()-1]);
			if (previous_token.type==val) {
				previous_token.len += cursor-start;
				return tokens.size()-1;
			}
		}
		Token t;
		t.type = val;
		t.start = (start-source);
		t.len = cursor-start;			
		tokens.push_back(t);
		return tokens.size()-1;
	}

	bool bol() {
		if ((start==source) || (start[-1]=='\n')) {
			memset(&lineflags, 0, sizeof(lineflags));
			return true;
		} else {
			return false;
		}
	}

	bool eol() const {
		return *cursor=='\n' || *cursor==0;
	}

	void newline() {
		if (line_startswith_section>=0) {
			tokens[line_startswith_section].type = t_text;
		}
		line_startswith_section = -1;
	}

	inline int scan();

	Py_UNICODE *source;

	Py_UNICODE *start;
	Py_UNICODE *cursor;
	Py_UNICODE *end;
	vector<Token> tokens;

	int line_startswith_section;
	int tablemode;
	struct {
		int rowchar;
	} lineflags;
};


int Scanner::scan()
{
	start=cursor;
	
	Py_UNICODE *marker=cursor;

	Py_UNICODE *save_cursor = cursor;


#define YYCTYPE         Py_UNICODE
#define YYCURSOR        cursor
#define YYMARKER	marker
#define YYLIMIT   (end)
// #define YYFILL(n) return 0;

#line 132 "_mwscan.re"


/*
  the re2c manpage says:
  "The user must arrange for a sentinel token to appear at the end of input"
  \000 is our sentinel token.
*/

#line 165 "_mwscan.re"

	if (!bol()) {
		goto not_bol;
	}

#line 148 "_mwscan.cc"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;

	yych = *YYCURSOR;
	if(yych <= '-') {
		if(yych <= '"') {
			if(yych <= 0x001F) goto yy18;
			if(yych <= ' ') goto yy2;
			if(yych <= '!') goto yy10;
			goto yy18;
		} else {
			if(yych <= ')') {
				if(yych <= '#') goto yy13;
				goto yy18;
			} else {
				if(yych <= '*') goto yy13;
				if(yych <= ',') goto yy18;
				goto yy17;
			}
		}
	} else {
		if(yych <= '<') {
			if(yych <= '9') goto yy18;
			if(yych <= ':') goto yy4;
			if(yych <= ';') goto yy15;
			goto yy18;
		} else {
			if(yych <= 'z') {
				if(yych <= '=') goto yy11;
				goto yy18;
			} else {
				if(yych <= '{') goto yy6;
				if(yych <= '|') goto yy8;
				goto yy18;
			}
		}
	}
yy2:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9') {
		if(yych <= 0x001F) goto yy3;
		if(yych <= '!') goto yy48;
	} else {
		if(yych <= ':') goto yy48;
		if(yych <= 'z') goto yy3;
		if(yych <= '|') goto yy48;
	}
yy3:
#line 209 "_mwscan.re"
	{RET(t_pre);}
#line 201 "_mwscan.cc"
yy4:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '*') {
		if(yych == '#') goto yy27;
		if(yych >= '*') goto yy27;
	} else {
		if(yych <= ':') {
			if(yych >= ':') goto yy43;
		} else {
			if(yych == '{') goto yy45;
		}
	}
yy5:
#line 215 "_mwscan.re"
	{RET(t_colon);}
#line 218 "_mwscan.cc"
yy6:
	++YYCURSOR;
	if((yych = *YYCURSOR) == '|') goto yy41;
yy7:
#line 219 "_mwscan.re"
	{goto not_bol;}
#line 225 "_mwscan.cc"
yy8:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= ',') {
		if(yych == '+') goto yy33;
	} else {
		if(yych <= '-') goto yy36;
		if(yych == '}') goto yy39;
	}
yy9:
#line 185 "_mwscan.re"
	{
		if (tablemode) {
		        lineflags.rowchar=cursor[-1];
			RET(t_column);
		}

		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 248 "_mwscan.cc"
yy10:
	yych = *++YYCURSOR;
	goto yy9;
yy11:
	++YYCURSOR;
	if((yych = *YYCURSOR) == '=') goto yy31;
	goto yy30;
yy12:
#line 210 "_mwscan.re"
	{
			line_startswith_section = found(t_section);
			return t_section;
		}
#line 262 "_mwscan.cc"
yy13:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy28;
yy14:
#line 214 "_mwscan.re"
	{RET(t_item);}
#line 270 "_mwscan.cc"
yy15:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy26;
yy16:
#line 216 "_mwscan.re"
	{RET(t_semicolon);}
#line 278 "_mwscan.cc"
yy17:
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '-') goto yy19;
	goto yy7;
yy18:
	yych = *++YYCURSOR;
	goto yy7;
yy19:
	yych = *++YYCURSOR;
	if(yych == '-') goto yy21;
yy20:
	YYCURSOR = YYMARKER;
	if(yyaccept <= 1) {
		if(yyaccept <= 0) {
			goto yy3;
		} else {
			goto yy5;
		}
	} else {
		goto yy7;
	}
yy21:
	yych = *++YYCURSOR;
	if(yych != '-') goto yy20;
yy22:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych == '-') goto yy22;
#line 217 "_mwscan.re"
	{RET(t_hrule);}
#line 310 "_mwscan.cc"
yy25:
	++YYCURSOR;
	yych = *YYCURSOR;
yy26:
	if(yych == ';') goto yy25;
	goto yy16;
yy27:
	++YYCURSOR;
	yych = *YYCURSOR;
yy28:
	if(yych == '#') goto yy27;
	if(yych == '*') goto yy27;
	goto yy14;
yy29:
	++YYCURSOR;
	yych = *YYCURSOR;
yy30:
	if(yych == 0x0009) goto yy29;
	if(yych == ' ') goto yy29;
	goto yy12;
yy31:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= 0x001F) {
		if(yych == 0x0009) goto yy29;
		goto yy12;
	} else {
		if(yych <= ' ') goto yy29;
		if(yych == '=') goto yy31;
		goto yy12;
	}
yy33:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych == '+') goto yy33;
#line 199 "_mwscan.re"
	{
		if (tablemode) 
			RET(t_tablecaption);
		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 356 "_mwscan.cc"
yy36:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych == '-') goto yy36;
#line 174 "_mwscan.re"
	{
		if (tablemode) 
			RET(t_row);
		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 371 "_mwscan.cc"
yy39:
	++YYCURSOR;
#line 171 "_mwscan.re"
	{--tablemode; RET(t_end_table);}
#line 376 "_mwscan.cc"
yy41:
	++YYCURSOR;
#line 170 "_mwscan.re"
	{++tablemode; RET(t_begin_table);}
#line 381 "_mwscan.cc"
yy43:
	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '*') {
		if(yych == '#') goto yy27;
		if(yych <= ')') goto yy5;
		goto yy27;
	} else {
		if(yych <= ':') {
			if(yych <= '9') goto yy5;
			goto yy43;
		} else {
			if(yych != '{') goto yy5;
		}
	}
yy45:
	yych = *++YYCURSOR;
	if(yych == '|') goto yy41;
	goto yy20;
yy46:
	yych = *++YYCURSOR;
	if(yych <= ',') {
		if(yych == '+') goto yy33;
		goto yy9;
	} else {
		if(yych <= '-') goto yy36;
		if(yych == '}') goto yy39;
		goto yy9;
	}
yy47:
	++YYCURSOR;
	yych = *YYCURSOR;
yy48:
	if(yych <= '9') {
		if(yych <= 0x001F) goto yy20;
		if(yych <= ' ') goto yy47;
		if(yych >= '"') goto yy20;
	} else {
		if(yych <= 'z') {
			if(yych <= ':') goto yy50;
			goto yy20;
		} else {
			if(yych <= '{') goto yy45;
			if(yych <= '|') goto yy46;
			goto yy20;
		}
	}
	yych = *++YYCURSOR;
	goto yy9;
yy50:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych == ':') goto yy50;
	if(yych == '{') goto yy45;
	goto yy20;
}
#line 220 "_mwscan.re"



not_bol:
	cursor = save_cursor;
	marker = cursor;


#line 448 "_mwscan.cc"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	yych = *YYCURSOR;
	if(yych <= 'Z') {
		if(yych <= '\'') {
			if(yych <= ' ') {
				if(yych <= 0x0000) goto yy75;
				if(yych == 0x000A) goto yy65;
				goto yy77;
			} else {
				if(yych <= '!') goto yy68;
				if(yych <= '%') goto yy77;
				if(yych <= '&') goto yy74;
				goto yy71;
			}
		} else {
			if(yych <= ';') {
				if(yych <= '/') goto yy77;
				if(yych <= '9') goto yy61;
				if(yych <= ':') goto yy70;
				goto yy77;
			} else {
				if(yych <= '<') goto yy73;
				if(yych <= '=') goto yy63;
				if(yych <= '@') goto yy77;
				goto yy61;
			}
		}
	} else {
		if(yych <= 'f') {
			if(yych <= '^') {
				if(yych <= '[') goto yy54;
				if(yych == ']') goto yy62;
				goto yy77;
			} else {
				if(yych <= '_') goto yy60;
				if(yych <= '`') goto yy77;
				if(yych <= 'e') goto yy61;
				goto yy58;
			}
		} else {
			if(yych <= 'm') {
				if(yych == 'h') goto yy59;
				if(yych <= 'l') goto yy61;
				goto yy56;
			} else {
				if(yych <= 'z') goto yy61;
				if(yych == '|') goto yy67;
				goto yy77;
			}
		}
	}
yy54:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch(yych) {
	case '[':	goto yy247;
	case 'f':	goto yy250;
	case 'h':	goto yy249;
	case 'm':	goto yy251;
	default:	goto yy55;
	}
yy55:
#line 269 "_mwscan.re"
	{RET(t_special);}
#line 515 "_mwscan.cc"
yy56:
	++YYCURSOR;
	if((yych = *YYCURSOR) == 'a') goto yy235;
	goto yy119;
yy57:
#line 235 "_mwscan.re"
	{RET(t_text);}
#line 523 "_mwscan.cc"
yy58:
	yych = *++YYCURSOR;
	if(yych == 't') goto yy227;
	goto yy119;
yy59:
	yych = *++YYCURSOR;
	if(yych == 't') goto yy217;
	goto yy119;
yy60:
	yych = *++YYCURSOR;
	if(yych == '_') goto yy120;
	goto yy119;
yy61:
	yych = *++YYCURSOR;
	goto yy119;
yy62:
	yych = *++YYCURSOR;
	if(yych == ']') goto yy116;
	goto yy55;
yy63:
	++YYCURSOR;
	if((yych = *YYCURSOR) == '=') goto yy114;
	goto yy113;
yy64:
#line 238 "_mwscan.re"
	{
			if (eol()) {
			        if (line_startswith_section>=0) {
				     line_startswith_section=-1;
				     RET(t_section_end);
                                } else {
				     RET(t_text);
                                }
			} else {
				RET(t_text);
			}
		    }
#line 561 "_mwscan.cc"
yy65:
	++YYCURSOR;
	if((yych = *YYCURSOR) == 0x000A) goto yy109;
#line 251 "_mwscan.re"
	{newline(); RET(t_newline);}
#line 567 "_mwscan.cc"
yy67:
	yych = *++YYCURSOR;
	if(yych <= '*') {
		if(yych == '!') goto yy105;
		goto yy55;
	} else {
		if(yych <= '+') goto yy107;
		if(yych == '|') goto yy105;
		goto yy55;
	}
yy68:
	++YYCURSOR;
	if((yych = *YYCURSOR) == '!') goto yy105;
yy69:
#line 279 "_mwscan.re"
	{RET(t_text);}
#line 584 "_mwscan.cc"
yy70:
	yych = *++YYCURSOR;
	goto yy55;
yy71:
	++YYCURSOR;
#line 270 "_mwscan.re"
	{RET(t_singlequote);}
#line 592 "_mwscan.cc"
yy73:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/') {
		if(yych == '!') goto yy89;
		if(yych <= '.') goto yy69;
		goto yy90;
	} else {
		if(yych <= 'Z') {
			if(yych <= '@') goto yy69;
			goto yy91;
		} else {
			if(yych <= '`') goto yy69;
			if(yych <= 'z') goto yy91;
			goto yy69;
		}
	}
yy74:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9') {
		if(yych == '#') goto yy78;
		if(yych <= '/') goto yy69;
		goto yy80;
	} else {
		if(yych <= 'Z') {
			if(yych <= '@') goto yy69;
			goto yy80;
		} else {
			if(yych <= '`') goto yy69;
			if(yych <= 'z') goto yy80;
			goto yy69;
		}
	}
yy75:
	++YYCURSOR;
#line 278 "_mwscan.re"
	{newline(); return t_end;}
#line 631 "_mwscan.cc"
yy77:
	yych = *++YYCURSOR;
	goto yy69;
yy78:
	yych = *++YYCURSOR;
	if(yych <= 'W') {
		if(yych <= '/') goto yy79;
		if(yych <= '9') goto yy85;
	} else {
		if(yych <= 'X') goto yy84;
		if(yych == 'x') goto yy84;
	}
yy79:
	YYCURSOR = YYMARKER;
	if(yyaccept <= 1) {
		if(yyaccept <= 0) {
			goto yy55;
		} else {
			goto yy69;
		}
	} else {
		goto yy57;
	}
yy80:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= ';') {
		if(yych <= '/') goto yy79;
		if(yych <= '9') goto yy80;
		if(yych <= ':') goto yy79;
	} else {
		if(yych <= 'Z') {
			if(yych <= '@') goto yy79;
			goto yy80;
		} else {
			if(yych <= '`') goto yy79;
			if(yych <= 'z') goto yy80;
			goto yy79;
		}
	}
yy82:
	++YYCURSOR;
#line 276 "_mwscan.re"
	{RET(t_entity);}
#line 676 "_mwscan.cc"
yy84:
	yych = *++YYCURSOR;
	if(yych == ';') goto yy79;
	goto yy88;
yy85:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '/') goto yy79;
	if(yych <= '9') goto yy85;
	if(yych == ';') goto yy82;
	goto yy79;
yy87:
	++YYCURSOR;
	yych = *YYCURSOR;
yy88:
	if(yych <= ';') {
		if(yych <= '/') goto yy79;
		if(yych <= '9') goto yy87;
		if(yych <= ':') goto yy79;
		goto yy82;
	} else {
		if(yych <= 'F') {
			if(yych <= '@') goto yy79;
			goto yy87;
		} else {
			if(yych <= '`') goto yy79;
			if(yych <= 'f') goto yy87;
			goto yy79;
		}
	}
yy89:
	yych = *++YYCURSOR;
	if(yych == '-') goto yy97;
	goto yy79;
yy90:
	yych = *++YYCURSOR;
	if(yych <= '@') goto yy79;
	if(yych <= 'Z') goto yy91;
	if(yych <= '`') goto yy79;
	if(yych >= '{') goto yy79;
yy91:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '>') {
		if(yych <= ';') {
			if(yych <= 0x0000) goto yy79;
		} else {
			if(yych <= '<') goto yy79;
			if(yych >= '>') goto yy95;
		}
	} else {
		if(yych <= 'Z') {
			if(yych >= 'A') goto yy91;
		} else {
			if(yych <= '`') goto yy93;
			if(yych <= 'z') goto yy91;
		}
	}
yy93:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '<') {
		if(yych <= 0x0000) goto yy79;
		if(yych <= ';') goto yy93;
		goto yy79;
	} else {
		if(yych != '>') goto yy93;
	}
yy95:
	++YYCURSOR;
#line 272 "_mwscan.re"
	{RET(t_html_tag);}
#line 749 "_mwscan.cc"
yy97:
	yych = *++YYCURSOR;
	if(yych != '-') goto yy79;
yy98:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= ';') {
		if(yych <= 0x0000) goto yy79;
		if(yych != '-') goto yy98;
	} else {
		if(yych == '=') goto yy98;
		if(yych <= '>') goto yy79;
		goto yy98;
	}
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= ';') {
		if(yych <= 0x0000) goto yy79;
		if(yych != '-') goto yy98;
	} else {
		if(yych == '=') goto yy98;
		if(yych <= '>') goto yy79;
		goto yy98;
	}
yy101:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= ';') {
		if(yych <= 0x0000) goto yy79;
		if(yych == '-') goto yy101;
		goto yy98;
	} else {
		if(yych <= '<') goto yy79;
		if(yych != '>') goto yy98;
	}
	++YYCURSOR;
#line 275 "_mwscan.re"
	{RET(t_comment);}
#line 788 "_mwscan.cc"
yy105:
	++YYCURSOR;
#line 253 "_mwscan.re"
	{
		if (tablemode) {
		        if (cursor[-2]!='!' || cursor[-2]==lineflags.rowchar) {
			       RET(t_column);
			}
		}
		cursor = start+1;
		RET(t_special);
	}
#line 801 "_mwscan.cc"
yy107:
	++YYCURSOR;
#line 263 "_mwscan.re"
	{
		if (tablemode) 
			RET(t_tablecaption);
		cursor = start+1;
		RET(t_special);
	}
#line 811 "_mwscan.cc"
yy109:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych == 0x000A) goto yy109;
#line 250 "_mwscan.re"
	{newline(); RET(t_break);}
#line 818 "_mwscan.cc"
yy112:
	++YYCURSOR;
	yych = *YYCURSOR;
yy113:
	if(yych == 0x0009) goto yy112;
	if(yych == ' ') goto yy112;
	goto yy64;
yy114:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= 0x001F) {
		if(yych == 0x0009) goto yy112;
		goto yy64;
	} else {
		if(yych <= ' ') goto yy112;
		if(yych == '=') goto yy114;
		goto yy64;
	}
yy116:
	++YYCURSOR;
#line 237 "_mwscan.re"
	{RET(t_2box_close);}
#line 841 "_mwscan.cc"
yy118:
	++YYCURSOR;
	yych = *YYCURSOR;
yy119:
	if(yych <= 'Z') {
		if(yych <= '/') goto yy57;
		if(yych <= '9') goto yy118;
		if(yych <= '@') goto yy57;
		goto yy118;
	} else {
		if(yych <= '_') {
			if(yych <= '^') goto yy57;
			goto yy118;
		} else {
			if(yych <= '`') goto yy57;
			if(yych <= 'z') goto yy118;
			goto yy57;
		}
	}
yy120:
	yych = *++YYCURSOR;
	switch(yych) {
	case 'E':	goto yy124;
	case 'F':	goto yy123;
	case 'N':	goto yy122;
	case 'S':	goto yy125;
	case 'T':	goto yy121;
	default:	goto yy119;
	}
yy121:
	yych = *++YYCURSOR;
	if(yych == 'O') goto yy214;
	goto yy119;
yy122:
	yych = *++YYCURSOR;
	if(yych == 'E') goto yy144;
	if(yych == 'O') goto yy145;
	goto yy119;
yy123:
	yych = *++YYCURSOR;
	if(yych == 'O') goto yy136;
	goto yy119;
yy124:
	yych = *++YYCURSOR;
	if(yych == 'N') goto yy133;
	goto yy119;
yy125:
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'A') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'R') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy119;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy119;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy119;
yy131:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto yy132;
		if(yych <= '9') goto yy118;
		if(yych >= 'A') goto yy118;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto yy118;
		} else {
			if(yych <= '`') goto yy132;
			if(yych <= 'z') goto yy118;
		}
	}
yy132:
#line 234 "_mwscan.re"
	{RET(t_magicword);}
#line 918 "_mwscan.cc"
yy133:
	yych = *++YYCURSOR;
	if(yych != 'D') goto yy119;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy119;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy131;
	goto yy119;
yy136:
	yych = *++YYCURSOR;
	if(yych != 'R') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'C') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'O') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'C') goto yy119;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy119;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy131;
	goto yy119;
yy144:
	yych = *++YYCURSOR;
	if(yych == 'W') goto yy201;
	goto yy119;
yy145:
	yych = *++YYCURSOR;
	switch(yych) {
	case 'C':	goto yy148;
	case 'E':	goto yy147;
	case 'G':	goto yy149;
	case 'T':	goto yy146;
	default:	goto yy119;
	}
yy146:
	yych = *++YYCURSOR;
	if(yych <= 'H') {
		if(yych == 'C') goto yy184;
		goto yy119;
	} else {
		if(yych <= 'I') goto yy185;
		if(yych == 'O') goto yy186;
		goto yy119;
	}
yy147:
	yych = *++YYCURSOR;
	if(yych == 'D') goto yy173;
	goto yy119;
yy148:
	yych = *++YYCURSOR;
	if(yych == 'C') goto yy157;
	if(yych == 'O') goto yy158;
	goto yy119;
yy149:
	yych = *++YYCURSOR;
	if(yych != 'A') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'L') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'L') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'R') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'Y') goto yy119;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy119;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy131;
	goto yy119;
yy157:
	yych = *++YYCURSOR;
	if(yych == '_') goto yy172;
	goto yy119;
yy158:
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'C') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'O') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'V') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'R') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy119;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy119;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy131;
	goto yy119;
yy172:
	yych = *++YYCURSOR;
	if(yych == '_') goto yy131;
	goto yy119;
yy173:
	yych = *++YYCURSOR;
	if(yych != 'I') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'S') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'C') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'I') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'O') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy119;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy119;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy131;
	goto yy119;
yy184:
	yych = *++YYCURSOR;
	if(yych == '_') goto yy200;
	goto yy119;
yy185:
	yych = *++YYCURSOR;
	if(yych == 'T') goto yy189;
	goto yy119;
yy186:
	yych = *++YYCURSOR;
	if(yych != 'C') goto yy119;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy119;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy131;
	goto yy119;
yy189:
	yych = *++YYCURSOR;
	if(yych != 'L') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'C') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'O') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'V') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'R') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy119;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy119;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy131;
	goto yy119;
yy200:
	yych = *++YYCURSOR;
	if(yych == '_') goto yy131;
	goto yy119;
yy201:
	yych = *++YYCURSOR;
	if(yych != 'S') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'E') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'C') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'T') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'I') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'O') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'L') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'I') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'N') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'K') goto yy119;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy119;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy131;
	goto yy119;
yy214:
	yych = *++YYCURSOR;
	if(yych != 'C') goto yy119;
	yych = *++YYCURSOR;
	if(yych != '_') goto yy119;
	yych = *++YYCURSOR;
	if(yych == '_') goto yy131;
	goto yy119;
yy217:
	yych = *++YYCURSOR;
	if(yych != 't') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'p') goto yy119;
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == ':') goto yy221;
	if(yych != 's') goto yy119;
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != ':') goto yy119;
yy221:
	yych = *++YYCURSOR;
	if(yych != '/') goto yy79;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy79;
	yych = *++YYCURSOR;
	if(yych <= '_') {
		if(yych <= ')') {
			if(yych <= '#') {
				if(yych == '!') goto yy224;
				if(yych <= '"') goto yy79;
			} else {
				if(yych <= '$') goto yy79;
				if(yych == '\'') goto yy79;
			}
		} else {
			if(yych <= '=') {
				if(yych <= '*') goto yy79;
				if(yych == '<') goto yy79;
			} else {
				if(yych <= '>') goto yy79;
				if(yych <= 'Z') goto yy224;
				if(yych <= '^') goto yy79;
			}
		}
	} else {
		if(yych <= 0x00D6) {
			if(yych <= '~') {
				if(yych <= '`') goto yy79;
				if(yych <= 'z') goto yy224;
				if(yych <= '}') goto yy79;
			} else {
				if(yych == 0x00C4) goto yy224;
				if(yych <= 0x00D5) goto yy79;
			}
		} else {
			if(yych <= 0x00E4) {
				if(yych == 0x00DC) goto yy224;
				if(yych <= 0x00E3) goto yy79;
			} else {
				if(yych <= 0x00F6) {
					if(yych <= 0x00F5) goto yy79;
				} else {
					if(yych != 0x00FC) goto yy79;
				}
			}
		}
	}
yy224:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '_') {
		if(yych <= ')') {
			if(yych <= '#') {
				if(yych == '!') goto yy224;
				if(yych >= '#') goto yy224;
			} else {
				if(yych <= '$') goto yy226;
				if(yych != '\'') goto yy224;
			}
		} else {
			if(yych <= '=') {
				if(yych <= '*') goto yy226;
				if(yych != '<') goto yy224;
			} else {
				if(yych <= '>') goto yy226;
				if(yych <= 'Z') goto yy224;
				if(yych >= '_') goto yy224;
			}
		}
	} else {
		if(yych <= 0x00D6) {
			if(yych <= '~') {
				if(yych <= '`') goto yy226;
				if(yych <= 'z') goto yy224;
				if(yych >= '~') goto yy224;
			} else {
				if(yych == 0x00C4) goto yy224;
				if(yych >= 0x00D6) goto yy224;
			}
		} else {
			if(yych <= 0x00E4) {
				if(yych == 0x00DC) goto yy224;
				if(yych >= 0x00E4) goto yy224;
			} else {
				if(yych <= 0x00F6) {
					if(yych >= 0x00F6) goto yy224;
				} else {
					if(yych == 0x00FC) goto yy224;
				}
			}
		}
	}
yy226:
#line 233 "_mwscan.re"
	{RET(t_http_url);}
#line 1245 "_mwscan.cc"
yy227:
	yych = *++YYCURSOR;
	if(yych != 'p') goto yy119;
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != ':') goto yy119;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy79;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy79;
	yych = *++YYCURSOR;
	if(yych <= '=') {
		if(yych <= '&') {
			if(yych <= '"') goto yy79;
			if(yych == '%') goto yy79;
		} else {
			if(yych <= '\'') goto yy79;
			if(yych <= ':') goto yy232;
			if(yych <= '<') goto yy79;
		}
	} else {
		if(yych <= '_') {
			if(yych <= '>') goto yy79;
			if(yych <= 'Z') goto yy232;
			if(yych <= '^') goto yy79;
		} else {
			if(yych <= '{') {
				if(yych <= '`') goto yy79;
			} else {
				if(yych <= '|') goto yy79;
				if(yych >= 0x007F) goto yy79;
			}
		}
	}
yy232:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '=') {
		if(yych <= '&') {
			if(yych <= '"') goto yy234;
			if(yych != '%') goto yy232;
		} else {
			if(yych <= '\'') goto yy234;
			if(yych <= ':') goto yy232;
			if(yych >= '=') goto yy232;
		}
	} else {
		if(yych <= '_') {
			if(yych <= '>') goto yy234;
			if(yych <= 'Z') goto yy232;
			if(yych >= '_') goto yy232;
		} else {
			if(yych <= '{') {
				if(yych >= 'a') goto yy232;
			} else {
				if(yych <= '|') goto yy234;
				if(yych <= '~') goto yy232;
			}
		}
	}
yy234:
#line 231 "_mwscan.re"
	{RET(t_http_url);}
#line 1309 "_mwscan.cc"
yy235:
	yych = *++YYCURSOR;
	if(yych != 'i') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'l') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 't') goto yy119;
	yych = *++YYCURSOR;
	if(yych != 'o') goto yy119;
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != ':') goto yy119;
	yych = *++YYCURSOR;
	if(yych == '@') goto yy79;
	goto yy242;
yy241:
	++YYCURSOR;
	yych = *YYCURSOR;
yy242:
	if(yych <= '9') {
		if(yych <= '\'') {
			if(yych == '!') goto yy241;
			if(yych <= '"') goto yy79;
			goto yy241;
		} else {
			if(yych <= ')') goto yy79;
			if(yych == ',') goto yy79;
			goto yy241;
		}
	} else {
		if(yych <= '?') {
			if(yych == '=') goto yy241;
			if(yych <= '>') goto yy79;
			goto yy241;
		} else {
			if(yych <= 'Z') {
				if(yych >= 'A') goto yy241;
			} else {
				if(yych <= ']') goto yy79;
				if(yych <= '~') goto yy241;
				goto yy79;
			}
		}
	}
	yych = *++YYCURSOR;
	if(yych <= '@') {
		if(yych <= '.') {
			if(yych <= ',') goto yy79;
		} else {
			if(yych <= '/') goto yy79;
			if(yych >= ':') goto yy79;
		}
	} else {
		if(yych <= '_') {
			if(yych <= 'Z') goto yy244;
			if(yych <= '^') goto yy79;
		} else {
			if(yych <= '`') goto yy79;
			if(yych >= '{') goto yy79;
		}
	}
yy244:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '@') {
		if(yych <= '.') {
			if(yych >= '-') goto yy244;
		} else {
			if(yych <= '/') goto yy246;
			if(yych <= '9') goto yy244;
		}
	} else {
		if(yych <= '_') {
			if(yych <= 'Z') goto yy244;
			if(yych >= '_') goto yy244;
		} else {
			if(yych <= '`') goto yy246;
			if(yych <= 'z') goto yy244;
		}
	}
yy246:
#line 229 "_mwscan.re"
	{RET(t_http_url);}
#line 1393 "_mwscan.cc"
yy247:
	++YYCURSOR;
#line 236 "_mwscan.re"
	{RET(t_2box_open);}
#line 1398 "_mwscan.cc"
yy249:
	yych = *++YYCURSOR;
	if(yych == 't') goto yy272;
	goto yy79;
yy250:
	yych = *++YYCURSOR;
	if(yych == 't') goto yy264;
	goto yy79;
yy251:
	yych = *++YYCURSOR;
	if(yych != 'a') goto yy79;
	yych = *++YYCURSOR;
	if(yych != 'i') goto yy79;
	yych = *++YYCURSOR;
	if(yych != 'l') goto yy79;
	yych = *++YYCURSOR;
	if(yych != 't') goto yy79;
	yych = *++YYCURSOR;
	if(yych != 'o') goto yy79;
	yych = *++YYCURSOR;
	if(yych != ':') goto yy79;
	yych = *++YYCURSOR;
	if(yych == '@') goto yy79;
	goto yy259;
yy258:
	++YYCURSOR;
	yych = *YYCURSOR;
yy259:
	if(yych <= '9') {
		if(yych <= '\'') {
			if(yych == '!') goto yy258;
			if(yych <= '"') goto yy79;
			goto yy258;
		} else {
			if(yych <= ')') goto yy79;
			if(yych == ',') goto yy79;
			goto yy258;
		}
	} else {
		if(yych <= '?') {
			if(yych == '=') goto yy258;
			if(yych <= '>') goto yy79;
			goto yy258;
		} else {
			if(yych <= 'Z') {
				if(yych >= 'A') goto yy258;
			} else {
				if(yych <= ']') goto yy79;
				if(yych <= '~') goto yy258;
				goto yy79;
			}
		}
	}
	yych = *++YYCURSOR;
	if(yych <= '@') {
		if(yych <= '.') {
			if(yych <= ',') goto yy79;
		} else {
			if(yych <= '/') goto yy79;
			if(yych >= ':') goto yy79;
		}
	} else {
		if(yych <= '_') {
			if(yych <= 'Z') goto yy261;
			if(yych <= '^') goto yy79;
		} else {
			if(yych <= '`') goto yy79;
			if(yych >= '{') goto yy79;
		}
	}
yy261:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '@') {
		if(yych <= '.') {
			if(yych >= '-') goto yy261;
		} else {
			if(yych <= '/') goto yy263;
			if(yych <= '9') goto yy261;
		}
	} else {
		if(yych <= '_') {
			if(yych <= 'Z') goto yy261;
			if(yych >= '_') goto yy261;
		} else {
			if(yych <= '`') goto yy263;
			if(yych <= 'z') goto yy261;
		}
	}
yy263:
#line 228 "_mwscan.re"
	{RET(t_urllink);}
#line 1491 "_mwscan.cc"
yy264:
	yych = *++YYCURSOR;
	if(yych != 'p') goto yy79;
	yych = *++YYCURSOR;
	if(yych != ':') goto yy79;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy79;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy79;
	yych = *++YYCURSOR;
	if(yych <= '=') {
		if(yych <= '&') {
			if(yych <= '"') goto yy79;
			if(yych == '%') goto yy79;
		} else {
			if(yych <= '\'') goto yy79;
			if(yych <= ':') goto yy269;
			if(yych <= '<') goto yy79;
		}
	} else {
		if(yych <= '_') {
			if(yych <= '>') goto yy79;
			if(yych <= 'Z') goto yy269;
			if(yych <= '^') goto yy79;
		} else {
			if(yych <= '{') {
				if(yych <= '`') goto yy79;
			} else {
				if(yych <= '|') goto yy79;
				if(yych >= 0x007F) goto yy79;
			}
		}
	}
yy269:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '=') {
		if(yych <= '&') {
			if(yych <= '"') goto yy271;
			if(yych != '%') goto yy269;
		} else {
			if(yych <= '\'') goto yy271;
			if(yych <= ':') goto yy269;
			if(yych >= '=') goto yy269;
		}
	} else {
		if(yych <= '_') {
			if(yych <= '>') goto yy271;
			if(yych <= 'Z') goto yy269;
			if(yych >= '_') goto yy269;
		} else {
			if(yych <= '{') {
				if(yych >= 'a') goto yy269;
			} else {
				if(yych <= '|') goto yy271;
				if(yych <= '~') goto yy269;
			}
		}
	}
yy271:
#line 230 "_mwscan.re"
	{RET(t_urllink);}
#line 1554 "_mwscan.cc"
yy272:
	yych = *++YYCURSOR;
	if(yych != 't') goto yy79;
	yych = *++YYCURSOR;
	if(yych != 'p') goto yy79;
	yych = *++YYCURSOR;
	if(yych == ':') goto yy276;
	if(yych != 's') goto yy79;
	yych = *++YYCURSOR;
	if(yych != ':') goto yy79;
yy276:
	yych = *++YYCURSOR;
	if(yych != '/') goto yy79;
	yych = *++YYCURSOR;
	if(yych != '/') goto yy79;
	yych = *++YYCURSOR;
	if(yych <= '_') {
		if(yych <= ')') {
			if(yych <= '#') {
				if(yych == '!') goto yy279;
				if(yych <= '"') goto yy79;
			} else {
				if(yych <= '$') goto yy79;
				if(yych == '\'') goto yy79;
			}
		} else {
			if(yych <= '=') {
				if(yych <= '*') goto yy79;
				if(yych == '<') goto yy79;
			} else {
				if(yych <= '>') goto yy79;
				if(yych <= 'Z') goto yy279;
				if(yych <= '^') goto yy79;
			}
		}
	} else {
		if(yych <= 0x00D6) {
			if(yych <= '~') {
				if(yych <= '`') goto yy79;
				if(yych <= 'z') goto yy279;
				if(yych <= '}') goto yy79;
			} else {
				if(yych == 0x00C4) goto yy279;
				if(yych <= 0x00D5) goto yy79;
			}
		} else {
			if(yych <= 0x00E4) {
				if(yych == 0x00DC) goto yy279;
				if(yych <= 0x00E3) goto yy79;
			} else {
				if(yych <= 0x00F6) {
					if(yych <= 0x00F5) goto yy79;
				} else {
					if(yych != 0x00FC) goto yy79;
				}
			}
		}
	}
yy279:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '_') {
		if(yych <= ')') {
			if(yych <= '#') {
				if(yych == '!') goto yy279;
				if(yych >= '#') goto yy279;
			} else {
				if(yych <= '$') goto yy281;
				if(yych != '\'') goto yy279;
			}
		} else {
			if(yych <= '=') {
				if(yych <= '*') goto yy281;
				if(yych != '<') goto yy279;
			} else {
				if(yych <= '>') goto yy281;
				if(yych <= 'Z') goto yy279;
				if(yych >= '_') goto yy279;
			}
		}
	} else {
		if(yych <= 0x00D6) {
			if(yych <= '~') {
				if(yych <= '`') goto yy281;
				if(yych <= 'z') goto yy279;
				if(yych >= '~') goto yy279;
			} else {
				if(yych == 0x00C4) goto yy279;
				if(yych >= 0x00D6) goto yy279;
			}
		} else {
			if(yych <= 0x00E4) {
				if(yych == 0x00DC) goto yy279;
				if(yych >= 0x00E4) goto yy279;
			} else {
				if(yych <= 0x00F6) {
					if(yych >= 0x00F6) goto yy279;
				} else {
					if(yych == 0x00FC) goto yy279;
				}
			}
		}
	}
yy281:
#line 232 "_mwscan.re"
	{RET(t_urllink);}
#line 1661 "_mwscan.cc"
}
#line 280 "_mwscan.re"

}


PyObject *py_scan(PyObject *self, PyObject *args) 
{
	PyObject *arg1;
	if (!PyArg_ParseTuple(args, "O:mwscan.scan", &arg1)) {
		return 0;
	}
	PyUnicodeObject *unistr = (PyUnicodeObject*)PyUnicode_FromObject(arg1);
	if (unistr == NULL) {
		PyErr_SetString(PyExc_TypeError,
				"parameter cannot be converted to unicode in mwscan.scan");
		return 0;
	}

	Py_UNICODE *start = unistr->str;
	Py_UNICODE *end = start+unistr->length;
	

	Scanner scanner (start, end);
	Py_BEGIN_ALLOW_THREADS
	while (scanner.scan()) {
	}
	Py_END_ALLOW_THREADS
	Py_XDECREF(unistr);
	
	// return PyList_New(0); // uncomment to see timings for scanning

	int size = scanner.tokens.size();
	PyObject *result = PyList_New(size);
	if (!result) {
		return 0;
	}
	
	for (int i=0; i<size; i++) {
		Token t = scanner.tokens[i];
		PyList_SET_ITEM(result, i, Py_BuildValue("iii", t.type, t.start, t.len));
	}
	
	return result;
}



static PyMethodDef module_functions[] = {
	{"scan", (PyCFunction)py_scan, METH_VARARGS, "scan(text)"},
	{0, 0},
};



extern "C" {
	DL_EXPORT(void) init_mwscan();
}

DL_EXPORT(void) init_mwscan()
{
	/*PyObject *m =*/ Py_InitModule("_mwscan", module_functions);
}
